/*
 * ar2c-lp-utils - bcd.h
 * 	version 0.0.0
 *
 * 	BCD->int int->BCD conversions
 * 
 * Copyright (C) 2005  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef BCD_H_INCLUDED
#define BCD_H_INCLUDED

#include <inttypes.h>
#include <errno.h>

#define BCD_ERR		0xff

static __inline__ uint8_t bcd2bin(uint8_t val)
{
	if ((val & 0x0f) >= 10)
		return BCD_ERR;
	if (val >> 4 >= 10)
		return BCD_ERR;
	return ((val >> 4) * 10 + (val & 0x0f));
}

static __inline__ uint8_t bin2bcd(uint8_t val)
{
	if (val >= 100)
		return BCD_ERR;
	return ((val / 10 << 4) + val % 10);
}

#endif
